// MyListBox.cpp : implementation file
//

#include "stdafx.h"
#include "ColorListBox.h"
#include "MyListBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyListBox

CMyListBox::CMyListBox()
{
}

CMyListBox::~CMyListBox()
{
}


BEGIN_MESSAGE_MAP(CMyListBox, CListBox)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////

void CMyListBox::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{

	COLORREF crBk = RGB(128, 128, 128);
	COLORREF crFrame = RGB(0, 0, 0);

	if (GetFocus() == this)
	{
		crBk = RGB(128, 28, 28);
		crFrame = RGB(200, 0, 0);
	}

	CDC dc;

	dc.Attach(lpDrawItemStruct->hDC);

	// Save these value to restore them when done drawing.
	COLORREF crOldTextColor = dc.GetTextColor();
	COLORREF crOldBkColor = dc.GetBkColor();

	// If this item is selected, set the background color  
	// and the text color to appropriate values. Also, erase 
	// rect by filling it with the background color. 
	if ((lpDrawItemStruct->itemAction | ODA_SELECT) &&
		(lpDrawItemStruct->itemState & ODS_SELECTED))
	{
		dc.SetTextColor(::GetSysColor(COLOR_HIGHLIGHTTEXT));
		dc.SetBkColor(::GetSysColor(COLOR_HIGHLIGHT));
		dc.FillSolidRect(&lpDrawItemStruct->rcItem, crBk);
	}
	else
	{
		dc.FillSolidRect(&lpDrawItemStruct->rcItem, crOldBkColor);
	}

	// If this item has the focus, draw a red frame around the 
	// item's rect. 
	if ((lpDrawItemStruct->itemAction | ODA_FOCUS) &&
		(lpDrawItemStruct->itemState & ODS_FOCUS))
	{
		CBrush br(crFrame);
		dc.FrameRect(&lpDrawItemStruct->rcItem, &br);
	}

	CString st;
	GetText(lpDrawItemStruct->itemID, st);

	lpDrawItemStruct->rcItem.left += 5;

	// Draw the text.
	dc.DrawText(
		st, st.GetLength(),
		&lpDrawItemStruct->rcItem,
		DT_LEFT | DT_SINGLELINE | DT_VCENTER);

	// Reset the background color and the text color back to their 
	// original values.
	dc.SetTextColor(crOldTextColor);
	dc.SetBkColor(crOldBkColor);

	dc.Detach();

}

void CMyListBox::MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct)
{
	// TODO: Add your code to determine the size of specified item
	ASSERT(lpMeasureItemStruct->CtlType == ODT_LISTBOX);

	CString strText(_T("&#00;"));
	GetText(lpMeasureItemStruct->itemID, strText);
	ASSERT(TRUE != strText.IsEmpty());
	CRect rect;
	GetItemRect(lpMeasureItemStruct->itemID, &rect);

	CDC* pDC = GetDC();
	lpMeasureItemStruct->itemHeight = pDC->DrawText(strText, -1, rect,
		DT_WORDBREAK | DT_CALCRECT);
	ReleaseDC(pDC);
}

int CMyListBox::CompareItem(LPCOMPAREITEMSTRUCT lpCompareItemStruct)
{
	return 0;
}
